summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2011-01-31 17:18:13 +0100
committerJim Meyering <meyering@redhat.com>2011-01-31 18:26:06 +0100
commit43d739e99c508a7c0fdfabc3c1aae844b029766f (patch)
tree84e5947ded9e7f1e3369075d264adcaaf111136a /tests/cp
parentcc0645fc643d3ea5a06f12f5fad784a2b8097888 (diff)
downloadcoreutils-43d739e99c508a7c0fdfabc3c1aae844b029766f.tar.xz
tests: exercise a rarely-used corner of copy.c
* tests/cp/sparse-to-pipe: New test. * tests/Makefile.am (TESTS): Add it.
Diffstat (limited to 'tests/cp')
-rwxr-xr-xtests/cp/sparse-to-pipe31
1 files changed, 31 insertions, 0 deletions
diff --git a/tests/cp/sparse-to-pipe b/tests/cp/sparse-to-pipe
new file mode 100755
index 000000000..4d39458e7
--- /dev/null
+++ b/tests/cp/sparse-to-pipe
@@ -0,0 +1,31 @@
+#!/bin/sh
+# copy a sparse file to a pipe, to exercise some seldom-used parts of copy.c
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ cp
+
+require_sparse_support_
+
+mkfifo_or_skip_ pipe
+timeout 10 cat pipe > copy &
+
+truncate -s1M sparse || framework_failure_
+cp sparse pipe || fail=1
+cmp sparse copy || fail=1
+
+Exit $fail